#ifndef BOSS_H
#define BOSS_H

#include "Entity.h"
#include "Sprite.h"

class Boss : public Entity
{
    public:
        enum Behavior
        {
            BEHAVE_IDLE,
            BEHAVE_TAUNT,
            BEHAVE_TELEPORT,
            BEHAVE_ATTACK
        };
        static const float W;
        static const float H;
        static const unsigned ATTACK_CHARGE;
        static const unsigned ATTACK_COOL;
        static const unsigned TELEPORT_FRAMES;
        static const unsigned IDLE_FRAMES;
        static const int HURT_TIME;
    public:
        Boss(float x, float y, unsigned difficultyLevel);
        virtual ~Boss();
        virtual bool hurt(int dmg);
        virtual void step();
        virtual void draw(sf::RenderTarget& window);
        virtual void doCollide(Entity* other);
    private:
        unsigned maxHp;
        unsigned difficulty;
        Behavior behave;
        unsigned attackCharge;
        unsigned attackCool;
        unsigned attackCounter;
        float prevX;
        float prevY;
        float teleportX;
        float teleportY;
        unsigned tpFrames;
        unsigned idleFrames;
        Sprite sprIdle;
        Sprite sprCast;
        Sprite sprWalk;
        Sprite sprDead;
        Sprite* currSprite;
        int hurtTimer;
        bool facingRight;
};

#endif // BOSS_H
