#ifndef CREEP_H
#define CREEP_H

#include "Entity.h"
#include "Sprite.h"

class Creep : public Entity
{
    public:
        static const int HURT_TIME;
        static const float WIDTH;
        static const float HEIGHT;
        static const float MAX_SPEED;
        static const float MAX_FORCE;
        static const float NEIGHBOR_RADIUS;
        static const float CLOSE_NEIGHBOR_RADIUS;


        Creep(float x, float y);
        virtual ~Creep();

        virtual bool hurt(int dmg);
        virtual void step();
        virtual void draw(sf::RenderTarget& window);
        virtual void doCollide(Entity* other);
    protected:
    private:
        sf::Vector2f seek(sf::Vector2f target);
        sf::Vector2f avoid(sf::Vector2f target);
        void flock();

        bool facingRight;
        Sprite sprite;

        sf::Vector2f acceleration;
        sf::Vector2f separation;
        sf::Vector2f alignment;
        sf::Vector2f cohesion;
        int neighborCount;
        int closeNeighborCount;

        int sleepTimer;
        int hurtTimer;
};

#endif // CREEP_H
