#ifndef ENTITY_H
#define ENTITY_H

#include "toolbox.h"
class Room;

class Entity
{
    public:
        enum EntityType
        {
            PLAYER,
            CREEP,
            TRAP,
            COMBAT_PARTICLE,
            ITEM,
            DOOR,
            BOSS
        };
        Entity(EntityType entityType, float x, float y, float w, float h);
        virtual ~Entity();

        void setRoom(Room* newRoom);
        virtual bool hurt(int dmg);
        virtual void step();
        virtual void draw(sf::RenderTarget& window);
        void drawBoundingBox(sf::RenderTarget& window);
        bool collidesWith(Entity* other);
        bool isOutOfBounds();
        virtual void doCollide(Entity* other);
        void collideRoom();

        EntityType entityType;
    protected:
        Room* room;
    public:
        float x;
        float y;
        bool die;
        float w;
        float h;
        float dx;
        float dy;
        int hp;
    protected:
        bool landedDown;
        bool landedLeft;
        bool landedRight;
        bool landedUp;
        bool bouncy;
    public:
        bool removeOnDie;
};

#endif // ENTITY_H
