#ifndef TRAP_H
#define TRAP_H

#include "Entity.h"
#include "Sprite.h"

class Trap : public Entity
{
    public:
        enum TrapType
        {
            ARROWTRAP,
            SPIKETRAP,
            HOLETRAP
        };
        static const float W;
        static const float H;
        static const unsigned ARROW_COOLDOWN;
        static const int ARROW_DAMAGE;
        static const unsigned SPIKE_TRIGGER;
        static const unsigned SPIKE_COOLDOWN;
        static const int SPIKE_DAMAGE;
        static const unsigned HOLE_DURABILITY;
        static const float HOLE_INFLUENCE;
    public:
        Trap(TrapType tt, float x, float y);
        virtual ~Trap();
        virtual bool hurt(int dmg);
        virtual void step();
        virtual void draw(sf::RenderTarget& window);
        virtual void doCollide(Entity* other);
    private:
        TrapType trapType;
        unsigned arrowCooldown;
        bool physical;
        bool spikeTriggered;
        unsigned spikeTriggerTimer;
        unsigned spikeCooldown;
        unsigned holeDurability;
        unsigned holeCrumbleSoundFrames;
        Sprite sprite;
};

#endif // TRAP_H
